Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Attributes | List of all members
LSH256_Base Class Reference

LSH-224 and LSH-256 hash base class. More...

Inheritance diagram for LSH256_Base:

## Public Member Functions
unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Restart ()
| Restart the hash. More...
void | Update (const byte *input, size_t size)
| Updates a hash with additional input. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Attributes
static const int | BLOCKSIZE = 128
| Block size, in bytes. More...

## Detailed Description

LSH-224 and LSH-256 hash base class.

LSH256_Base is the base class for both LSH-224 and LSH-256

Since
  Crypto++ 8.6

Definition at line 34 of file lsh.h.

## Member Function Documentation

## ◆ BlockSize()

unsigned int LSH256_Base::BlockSize | ( |  | ) | const
| inline virtual

Provides the block size of the compression function.

Returns
  block size of the compression function, in bytes

BlockSize() will return 0 if the hash is not block based or does not have an equivalent block size. For example, Keccak and SHA-3 do not have a block size, but they do have an equivalent block size called rate expressed as `r`.

Reimplemented from HashTransformation.

Definition at line 43 of file lsh.h.

## ◆ DigestSize()

unsigned int LSH256_Base::DigestSize | ( |  | ) | const
| inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 44 of file lsh.h.

## ◆ OptimalDataAlignment()

unsigned int LSH256_Base::OptimalDataAlignment | ( |  | ) | const
| inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 45 of file lsh.h.

## ◆ Restart()

void LSH256_Base::Restart | ( |  | ) |
| virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

## ◆ Update()

void LSH256_Base::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |
| virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

## ◆ TruncatedFinal()

void LSH256_Base::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |
| virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

## ◆ AlgorithmProvider()

std::string LSH256_Base::AlgorithmProvider | ( |  | ) | const
| virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from Algorithm.

## Member Data Documentation

## ◆ BLOCKSIZE

const int LSH256_Base::BLOCKSIZE = 128
| static

Block size, in bytes.

LSH_256 uses LSH256_MSG_BLK_BYTE_LEN for block size, which is 128

Definition at line 39 of file lsh.h.

The documentation for this class was generated from the following file:

- lsh.h